package trader.brokers.dukascopy.test;

import java.io.FileWriter;
import java.sql.Date;
import java.text.SimpleDateFormat;
import java.util.TimeZone;

import com.dukascopy.api.Instrument;
import com.dukascopy.api.LoadingDataListener;
import com.dukascopy.api.LoadingProgressListener;
import com.dukascopy.api.OfferSide;
import com.dukascopy.api.Period;

public class Listener implements LoadingDataListener, LoadingProgressListener {

	private String fileName;
	private FileWriter fileWriter;
	private volatile boolean finished = false;
	
	public Listener(String fileName) {
		this.fileName = fileName;
	}

	@Override
	public void dataLoaded(long start, long end, long currentPosition,
			String information) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void loadingFinished(boolean allDataLoaded, long start, long end,
			long currentPosition) {
		if (fileWriter != null) {
			try {
				fileWriter.close();
			} catch (Exception ex) {
				
			}
		}
		
		finished = true;
	}

	
	public boolean isFinished() {
		return finished;
	}

	@Override
	public boolean stopJob() {
		// TODO Auto-generated method stub
		return false;
	}

	private String format(long time) {
		try {
			Date date = new Date(time);

			SimpleDateFormat sdf = new SimpleDateFormat(
					"yyyy-MM-dd HH:mm:ss.SSS");
			sdf.setTimeZone(TimeZone.getTimeZone("UTC"));
			return sdf.format(date);

		} catch (Exception ex) {
			ex.printStackTrace();
			System.exit(1);
		}

		return null;
	}
	
	@Override
	public void newTick(Instrument instrument, long time, double ask,
			double bid, double askVol, double bidVol) {
		try {
			if (fileWriter == null) {
				fileWriter = new FileWriter(fileName);
			}
			
			String str = format(time) + "," + bid + "," + ask + "\n";
			System.out.print(instrument.toString().replace("/", "") + "," + str);
			fileWriter.write(str);
			fileWriter.flush();
			
		} catch (Exception ex) {
			ex.printStackTrace();
			System.exit(1);
		}
	}

	@Override
	public void newBar(Instrument instrument, Period period, OfferSide side,
			long time, double open, double close, double low, double high,
			double vol) {
		// TODO Auto-generated method stub
		
	}

}
